
static enum CLIENT_EVENT_ID
{
	CLIENT_EVENT_6HZ=64,
	CLIENT_EVENT_SECOND
};

static enum DATA_DEFINE_ID
{
	DATA_DEFINITION_BATTERY_VOLTAGE=128,
};

void OnRecvOpen (SIMCONNECT_RECV_OPEN *pOpen, DWORD cbData)
{
	hr = SimConnect_SubscribeToSystemEvent( hSimConnect, CLIENT_EVENT_SECOND, "1sec" );
	if ( SUCCEEDED(hr) ) hr = SimConnect_AddToDataDefinition(hSimConnect, DATA_DEFINITION_BATTERY_VOLTAGE, "ELECTRICAL BATTERY VOLTAGE", "Volts",SIMCONNECT_DATATYPE_FLOAT64,0);
}
void OnRecvEvent (SIMCONNECT_RECV_EVENT *pEvent, DWORD cbData)
{
	if ( fChargeOn != 0. && pEvent->uEventID == CLIENT_EVENT_SECOND )
		{
		lookup_var( &mvVolts );
		fVoltsOut = mvVolts.var_value.n + 0.05;
		if( fVoltsOut > 24. ) fVoltsOut = 24.;
		SimConnect_SetDataOnSimObject(hSimConnect, DATA_DEFINITION_BATTERY_VOLTAGE, SIMCONNECT_OBJECT_ID_USER, 0, 1, sizeof(fVoltsOut), &fVoltsOut);
		}
}
void OnRecvSimobjectData(SIMCONNECT_RECV_SIMOBJECT_DATA *pData, DWORD cbData)
{
}
void OnRecvSimobjectDataByType(SIMCONNECT_RECV_SIMOBJECT_DATA_BYTYPE *pObjData, DWORD cbData)
{
}
void OnRecvSimObjectFrame( SIMCONNECT_RECV_EVENT_FRAME *pFrame, DWORD cbData )
{
}
void OnRecvWeatherObservation(SIMCONNECT_RECV_WEATHER_OBSERVATION *pWeather)
{
}
void OnRecvException(SIMCONNECT_RECV_EXCEPTION *px, DWORD cbData)
{
}
