#include "fsxgauges_sp2.h"
#include "dsd_battery_charger.h"

// LVAR.H defines a class I created to handle XML L:Variables.
#include "LVAR.H"

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <iostream>
#include "SimConnect.h"

// 25
NONLINEARITY Nonlin2[] = 
{
{{18, 226},   0, 0},
{{2, 124},   5, 0},
{{52, 34},   10, 0},
{{150, 1},   15, 0},
{{247, 34},   20, 0},
{{298, 124},   25, 0},
{{282, 226},   30, 0},
};
#define MAX_VALUE 30

// char variable to hold the path qualified name of the gauge.
char GaugeName[MAX_PATH];
double fChargeOn = 0.;
double fVoltsOut;
int j = 0;
int i = 0;
HINSTANCE ThisModule;
HANDLE hSimConnect;
HRESULT hr;

MODULE_VAR mvVolts = {BATTERY_VOLTAGE};
LVAR lvBC;

#include "SimConnectProcs.cpp"
void CALLBACK SimConnectProcess(SIMCONNECT_RECV *pData, DWORD cbData, void *pContext)
{
	switch (pData->dwID)
	{
	case SIMCONNECT_RECV_ID_OPEN: //2
	OnRecvOpen((SIMCONNECT_RECV_OPEN*)pData, cbData);
	break;

	case SIMCONNECT_RECV_ID_EVENT: //4
	OnRecvEvent((SIMCONNECT_RECV_EVENT*)pData, cbData);
	break;

	case SIMCONNECT_RECV_ID_EVENT_FRAME: //7
		OnRecvSimObjectFrame( (SIMCONNECT_RECV_EVENT_FRAME*)pData, cbData );
	break;
	case SIMCONNECT_RECV_ID_SIMOBJECT_DATA: //8
	OnRecvSimobjectData((SIMCONNECT_RECV_SIMOBJECT_DATA*)pData, cbData);
	break;

	case SIMCONNECT_RECV_ID_SIMOBJECT_DATA_BYTYPE: //9
	OnRecvSimobjectDataByType((SIMCONNECT_RECV_SIMOBJECT_DATA_BYTYPE*)pData, cbData);
	break;

	case SIMCONNECT_RECV_ID_WEATHER_OBSERVATION: //10
	OnRecvWeatherObservation((SIMCONNECT_RECV_WEATHER_OBSERVATION*)pData);
	break;

	case SIMCONNECT_RECV_ID_EXCEPTION: //1
	OnRecvException((SIMCONNECT_RECV_EXCEPTION*)pData, cbData);
	break;
	}
}

void FSAPI	module_init(void)
	{
	GetModuleFileName( ThisModule, GaugeName, MAX_PATH );
	SimConnect_Open(&hSimConnect, GaugeName, NULL, 0, NULL, SIMCONNECT_OPEN_CONFIGINDEX_LOCAL);
	SimConnect_CallDispatch(hSimConnect, SimConnectProcess, NULL);
	lvBC.Register("BatteryCharger");
	}		

void FSAPI	module_deinit(void)
	{
	SimConnect_Close(hSimConnect);
	}

BOOL WINAPI DllMain (HINSTANCE hDLL, DWORD dwReason, LPVOID lpReserved)	
{
	ThisModule = hDLL;
	return TRUE;
}

#define	GAUGE_NAME  "charger\0"
#define	GAUGEHDR_VAR_NAME  gaugehdr_charger
#define	GAUGE_W    50
#include	"dsd_battery_charger0.cpp"
#undef	GAUGEHDR_VAR_NAME
#undef	GAUGE_NAME
// #undef	GAUGE_W

#define	GAUGE_NAME  "digital meter\0"
#define	GAUGEHDR_VAR_NAME  gaugehdr_meter_digital
#include	"dsd_battery_charger_meter_digital.cpp"
#undef	GAUGEHDR_VAR_NAME
#undef	GAUGE_NAME
#undef	GAUGE_W

#define	GAUGE_NAME  "meter\0"
#define	GAUGEHDR_VAR_NAME  gaugehdr_meter
#define	GAUGE_W    80
#include	"dsd_battery_charger_meter.cpp"
#undef	GAUGEHDR_VAR_NAME
#undef	GAUGE_NAME
#undef	GAUGE_W

GAUGESIMPORT	ImportTable =							
{														
	{ 0x0000000F, (PPANELS)NULL },
	{ 0x00000000, NULL }								
};

GAUGESLINKAGE	Linkage =								
{														
	0x00000013,											
	module_init,										
	module_deinit,										
	0,													
	0,
	FS9LINK_VERSION, 
	{
		(&gaugehdr_charger),
		(&gaugehdr_meter),
		(&gaugehdr_meter_digital),
		0 
	}
};
