
#include "fsxgauges_sp2.h"

#include "lvar.h"

LVAR::LVAR()
:
id_number(-1),
value(0.)
	{
	ZeroMemory(name,MAX_PATH*sizeof(char));
	}

LVAR::~LVAR()
	{
	}

char* FSAPI LVAR::GetName()
	{
	if ( name )	return name;
	else return NULL;
	}
int FSAPI LVAR::GetID()
	{
	return id_number;
	}

HRESULT FSAPI LVAR::Register(char* NameIn)
	{
	strcpy_s(name, strlen(NameIn)+1, NameIn);
	id_number = register_named_variable( name );
	if (!id_number) id_number = check_named_variable(name);
	value = get_named_variable_value ( id_number );
	return S_OK;
	}
HRESULT FSAPI LVAR::Check()
	{
	id_number = check_named_variable( name );
	return id_number;
	}
HRESULT FSAPI LVAR::Check(char* NameIn)
	{
	strcpy_s ( name, strlen(NameIn)+1, NameIn );
	if (id_number <= 0 ) id_number = register_named_variable( name );
	id_number = check_named_variable( name );
	return id_number;
	}
HRESULT FSAPI LVAR::SetLVar(double AmountIn)
	{
	set_named_variable_value ( id_number, AmountIn );
	return S_OK;
	}

HRESULT FSAPI LVAR::SetLVar(char* NameIn, double AmountIn)
	{
	strcpy_s ( name, strlen(NameIn)+1, NameIn );
	if ( id_number < 0 ) id_number = register_named_variable( name );
	id_number = check_named_variable( name );
	set_named_variable_value ( id_number, AmountIn );
	return S_OK;
	}

double FSAPI LVAR::GetLVar()
	{
	return value;
	}

double FSAPI LVAR::UpdateAndGet()
	{
	value = get_named_variable_value ( id_number );
	return value;
	}

double FSAPI LVAR::UpdateAndGet(char* NameIn)
	{
	strcpy_s ( name, strlen(NameIn)+1, NameIn );
	if ( id_number < 0 ) id_number = register_named_variable( name );
	id_number = check_named_variable( name );
	value = get_named_variable_value ( id_number );
	return value;
	}
void FSAPI LVAR::Update()
	{
	value = get_named_variable_value ( id_number );
	}